.global _start

_start:
	.org 0x00
	.word 0x3B513B51		@ "Q;Q;" magic.
	.org 0x08
	.word _end - _start		@ Length
	.word 0x10001
	.org 0x14
	.asciz "LDR"			@ Block name.
	.org 0x64
	.word entryvector		@ Entry vector address.
	.org 0x68
	.word 0xB513B513
	.org 0x6c
	.word 0x10002000		@ Module load address.
	.org 0x70
	.word 0x0			@ Not compressed.
	.word 0x0
	.word 0x0

entryvector:
	.word 0
	.word _asmstart

_asmstart:
	mov r0, #0xD3
	msr cpsr_c, r0			@ FIQ/IRQ disabled, supervisor.

	/*
	 * Set up 925T mode.
	 */
	mov r1, #0x81
	mcr p15, 0, r1, c15, c1, 0

	/*
	 * Mask all IRQs by setting all bits in the INTMR - default.
	 */
	mov r1, #0xffffffff
	ldr r0, =0xfffecb04
	str r1, [r0]
	ldr r0, =0xfffe0004
	str r1, [r0]

	/*
	 * flush v4 I/D caches
	 */
	mov r0, #0
	mcr p15, 0, r0, c7, c7, 0		/* flush v3/v4 cache */
	mcr p15, 0, r0, c8, c7, 0		/* flush v4 TLB */

	/*
	 * Disable MMU stuff and caches.
	 */
	mrc	p15, 0, r0, c1, c0, 0
	bic	r0, r0, #0x00002300
	bic	r0, r0, #0x00000087
	orr	r0, r0, #0x00000002
	orr	r0, r0, #0x00001000
	mcr	p15, 0, r0, c1, c0, 0

	ldr sp, stack			@ Set a stack.

	mov r1, #0x24			@ Light up voice/email LEDs.
	mov r0, #0x1000000
	strb r1, [r0]
	
	bl c_entry

loop:	b loop

stack:
	.word 0x20003000
